;; TODO - make mode-line indicator prominent by placing it first, like in Evil

(use-package god-mode
  :bind ("<escape>" . god-mode-all)
  :init (god-mode-all)
  :config
  ;; from https://github.com/chrisdone/god-mode#change-modeline-color
  (defun c/god-mode-update-cursor ()
    (cond ((or god-local-mode buffer-read-only)
           (progn
             (setq cursor-type 'box)
             (set-face-background 'mode-line "black")
             (set-face-background 'mode-line-inactive "black")))
          (t
           (progn
             (setq cursor-type 'bar)
             (set-face-background 'mode-line "dark red")
             (set-face-background 'mode-line-inactive "dark red")))))
  (add-hook 'god-mode-enabled-hook #'c/god-mode-update-cursor)
  (add-hook 'god-mode-disabled-hook #'c/god-mode-update-cursor)
  :custom
  (god-exempt-major-modes nil)
  (god-exempt-predicates nil))

;; for helm
;; (define-key helm-map (kbd "<escape>") 'god-local-mode)

(use-package god-mode-isearch
  :bind
  ((:map isearch-mode-map
         ("<escape>" . god-mode-isearch-activate))
   (:map god-mode-isearch-map
         ("<escape>" . god-mode-isearch-disable))))
