;; (require 'chicken)

(setq print-length nil
      eval-expression-print-length nil)

;; (require 'slime)
(require 'slime-autoloads)
(global-set-key (kbd "<f5> s") 'slime)
(with-eval-after-load 'slime
  (slime-setup)
  (setq inferior-lisp-program
        ;; "/usr/bin/sbcl"
        "/usr/bin/ecl"
        )
  (cp-set-keys
   :keymap slime-mode-map
   :bindings
   `((,(kbd "M-n")   next-line)
     (,(kbd "M-p")   previous-line)
     (,(kbd "SPC")   self-insert-command))))

(defun set-cl-repl-keys ()
  (if (or (cp-buffer-name-match-p "^\*inferior-lisp\*\\(<[0-9]*>\\)?")
          (eq major-mode 'lisp-mode))
      (progn
        (local-set-key (kbd "TAB") 'completion-at-point)
        (local-set-key (kbd "M-q") 'sp-indent-defun))))

(add-hook 'slime-connected-hook 'set-cl-repl-keys)
(add-hook 'comint-mode-hook     'set-cl-repl-keys)
(add-hook 'lisp-mode-hook       'set-cl-repl-keys)

(setq scheme-program-name "csi -:c")
(setq comint-prompt-read-only t)

(add-to-list 'auto-mode-alist '("\\.scm\\'" . scheme-mode))
;; (add-to-list 'auto-mode-alist '("\\.scm\\'" . geiser-mode))
;; (require 'geiser)

;; ;; 2017-06-12T14:51:30+0530 - dropping geiser in favor of scheme-mode
;; (autoload 'run-chicken "geiser-mode" "geiser-mode." t)
;; (autoload 'run-guile   "geiser-mode" "geiser-mode." t)
;; (autoload 'geiser-mode "geiser-mode" "geiser-mode." t)
;; (with-eval-after-load 'geiser-mode
;;   (setq geiser-mode-smart-tab-p t)
;;   (define-key geiser-mode-map (kbd "C-.") nil)
;;   ;; (cp-set-keys
;;   ;;  :unset t
;;   ;;  :keymap geiser-mode-map
;;   ;;  :bindings
;;   ;;  `((,(kbd "C-."))))
;;   )

(define-key emacs-lisp-mode-map (kbd "<tab>") 'completion-at-point)

(add-hook 'emacs-lisp-mode-hook 'eldoc-mode)
(setq eldoc-idle-delay 0)

(update-file-autoloads "~/.emacs.d/elisp-git/clojure-mode/clojure-mode.el"
                       t
                       "~/.emacs.d/elisp-git/clojure-mode/clojure-autoloads.el")
(load "clojure-autoloads")
;; (autoload 'clojure-mode "clojure-mode" nil t)
(with-eval-after-load "clojure-mode"
  (require 'cider))
